package dev.pfaff.altargui.util.listenable;

import java.util.function.Consumer;
import java.util.function.Function;

public record ConstantValue<T>(T value) implements ValueListenable<T> {
	@Override
	public ListenerDisposer addListener(Runnable listener) {
		listener.run();
		return () -> {};
	}

	@Override
	public ListenerDisposer addListener(Consumer<T> listener) {
		listener.accept(value);
		return () -> {};
	}

	@Override
	public <R> ValueListenable<R> map(Function<T, R> mapper) {
		return new ConstantValue<>(mapper.apply(value));
	}
}
